Index: /trunk/include/cf_base.h
===================================================================
--- /trunk/include/cf_base.h	(revision 49)
+++ /trunk/include/cf_base.h	(revision 50)
@@ -49,9 +49,9 @@
 
 /** Windows 에서의 함수 EXPORT 구문 정의 */
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # define CF_EXPORT		__declspec(dllexport)
-#else // #ifdef _WIN32
+#else
 # define CF_EXPORT
-#endif // #ifdef _WIN32
+#endif
 
 #endif // #ifndef __CF_BASE_H__
Index: /trunk/include/cf_debug.h
===================================================================
--- /trunk/include/cf_debug.h	(revision 49)
+++ /trunk/include/cf_debug.h	(revision 50)
@@ -22,5 +22,5 @@
 
 /** Windows 함수 이름 매크로 재정의 */
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # define __func__	__FUNCTION__
 #endif
Index: /trunk/include/cf_thread.h
===================================================================
--- /trunk/include/cf_thread.h	(revision 49)
+++ /trunk/include/cf_thread.h	(revision 50)
@@ -13,11 +13,11 @@
 #include "cf_base.h"
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # define CF_THREAD_RETURN	unsigned int	/**< 스레드 워커 함수 반환 형 */
 # define CF_THREAD_CALL		__stdcall		/**< 스레드 워커 함수 호출 규약 */
-#else // #ifdef _WIN32
+#else
 # define CF_THREAD_RETURN	void *			/**< 스레드 워커 함수 반환 형 */
 # define CF_THREAD_CALL						/**< 스레드 워커 함수 호출 규약 */
-#endif // #ifdef _WIN32
+#endif
 
 /** 스레드 워커 함수 형태이며, CF_Thread_Function 형식 */
Index: /trunk/src/cf_debug.c
===================================================================
--- /trunk/src/cf_debug.c	(revision 49)
+++ /trunk/src/cf_debug.c	(revision 50)
@@ -13,5 +13,5 @@
 #include <string.h>
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # include <io.h>
 #else
Index: /trunk/src/cf_file.c
===================================================================
--- /trunk/src/cf_file.c	(revision 49)
+++ /trunk/src/cf_file.c	(revision 50)
@@ -11,5 +11,5 @@
 #include <sys/stat.h>
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # include <io.h>
 
@@ -36,10 +36,10 @@
 /*------------------------------*/
 # define S_IRWXU		0x00000000
-#else // #ifdef _WIN32
+#else // #if defined(_WIN32) || defined(_WIN64)
 # include <unistd.h>
 
 # define DELIMITER		'/'
 # define O_BINARY		0x00000000
-#endif // #ifdef _WIN32
+#endif // #if defined(_WIN32) || defined(_WIN64)
 
 #define DIRECTORY_MODE	S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH
Index: /trunk/src/cf_log.c
===================================================================
--- /trunk/src/cf_log.c	(revision 49)
+++ /trunk/src/cf_log.c	(revision 50)
@@ -4,5 +4,5 @@
  * @version	0.1
  */
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # define _USE_32BIT_TIME_T
 #endif
@@ -20,10 +20,10 @@
 #include <time.h>
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # define snprintf		_snprintf
 # include <Windows.h>
-#else // #ifdef _WIN32
+#else
 # include <sys/time.h>
-#endif // #ifdef _WIN32
+#endif
 
 #define CHECK_INVALID_CTX(__ctx)		(__ctx == NULL)
@@ -130,6 +130,6 @@
 	return 0;
 }
-#endif // #if defined(_WIN32) || defined(_WIN64)
 /* }}} #if defined(_WIN32) || defined(_WIN64) */
+#endif
 
 static int
Index: /trunk/src/cf_socket.c
===================================================================
--- /trunk/src/cf_socket.c	(revision 49)
+++ /trunk/src/cf_socket.c	(revision 50)
@@ -11,5 +11,5 @@
 #include <string.h>
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 /* for windows {{{ */
 # include <WinSock2.h>
@@ -37,5 +37,5 @@
 		return CF_ERROR_SOCKET_INVALID_SOCKET
 
-#ifdef WIN32
+#if defined(_WIN32) || defined(_WIN64)
 typedef int					socklen_t;
 # define sa_family_t		unsigned short
@@ -56,5 +56,5 @@
 								CF_BOOL		boolean)
 {
-#ifdef WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	unsigned long mode = (boolean == CF_TRUE) ? 1 : 0;
 	ioctlsocket (sock, FIONBIO, &mode);
@@ -151,5 +151,5 @@
 CF_Socket_Initialize (void)
 {
-#ifdef WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	WSADATA winsockData;
 	if (WSAStartup (MAKEWORD (2, 0), &winsockData))
@@ -171,5 +171,5 @@
 	CHECK_SOCKET_INIT ();
 
-#ifdef WIN32
+#if defined(_WIN32) || defined(_WIN64)
    	if (WSACleanup ())
 	   return CF_ERROR_SOCKET_FINALIZE;
@@ -224,5 +224,5 @@
 						 SOL_SOCKET,
 						 optname,
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 						 (char *) optval,
 #else
@@ -259,5 +259,5 @@
 						 SOL_SOCKET,
 						 optname,
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 						 (char *) optval,
 #else
Index: /trunk/src/cf_thread.c
===================================================================
--- /trunk/src/cf_thread.c	(revision 49)
+++ /trunk/src/cf_thread.c	(revision 50)
@@ -10,14 +10,14 @@
 #include <stdlib.h>
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 # include <windows.h>
 # include <process.h>
 # define THREAD_TYPE	HANDLE
 # define MUTEX_TYPE		HANDLE
-#else // #ifdef _WIN32
+#else // #if defined(_WIN32) || defined(_WIN64)
 # include <pthread.h>
 # define THREAD_TYPE	pthread_t
 # define MUTEX_TYPE		pthread_mutex_t
-#endif // #ifdef _WIN32
+#endif // #if defined(_WIN32) || defined(_WIN64)
 
 #define CHECK_INVALID_THREAD(__h)		\
@@ -32,5 +32,5 @@
 CF_Thread_Local_Close (void * ctx)
 {
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	CloseHandle (ctx);
 #else
@@ -57,5 +57,5 @@
 	int result = 0;
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	*threadID = (THREAD_TYPE) _beginthreadex (0, 0, callback, arg, 0, 0);
 	if (*threadID == NULL)
@@ -105,5 +105,5 @@
 	CHECK_INVALID_THREAD (*threadID);
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	WaitForSingleObject ((THREAD_TYPE) *threadID, INFINITE);
 #else
@@ -129,5 +129,5 @@
 	int result = 0;
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	*mutex = (MUTEX_TYPE) CreateMutexA (NULL, FALSE, NULL);
 	if (*mutex == NULL)
@@ -175,5 +175,5 @@
 	CHECK_INVALID_MUTEX (*mutex);
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	WaitForSingleObject ((MUTEX_TYPE) *mutex, INFINITE);
 #else
@@ -196,5 +196,5 @@
 	CHECK_INVALID_MUTEX (*mutex);
 
-#ifdef _WIN32
+#if defined(_WIN32) || defined(_WIN64)
 	ReleaseMutex (*mutex);
 #else